﻿Imports System.Text
Imports System.Text.RegularExpressions
Public Class IPCtrl
    Private Sub TextBox1_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.GotFocus, TextBox2.GotFocus, TextBox3.GotFocus, TextBox4.GotFocus
        CType(sender, TextBox).SelectionStart = 0
        CType(sender, TextBox).SelectionLength = CType(sender, TextBox).Text.Length
    End Sub
    Private Sub TextBox1_G(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged, TextBox2.TextChanged, TextBox3.TextChanged, TextBox4.TextChanged
        Dim textCtrl As TextBox
        Dim text As String
        Dim value As Integer
        textCtrl = sender
        text = textCtrl.Text
        If (Not Integer.TryParse(text, value)) Then
            textCtrl.Text = ""
        Else
            If value > 255 Then
                textCtrl.Text = 255
            ElseIf value < 0 Then
                textCtrl.Text = 255
            End If
        End If

    End Sub
    Private Sub TextBox1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextBox1.KeyPress, TextBox4.KeyPress, TextBox3.KeyPress, TextBox2.KeyPress
        Dim textCtrl As TextBox
        Dim text As String
        'Dim value As Integer
        textCtrl = sender
        text = textCtrl.Text
        Select Case Char.GetUnicodeCategory(e.KeyChar)
            Case Globalization.UnicodeCategory.DecimalDigitNumber
                text += e.KeyChar
            Case Globalization.UnicodeCategory.Control
                text = ""
            Case Else
                e.Handled = True
        End Select
        If textCtrl.SelectionLength = 0 Then
            If (e.KeyChar.ToString() = ".") Or (text.Length >= 3) Then
                'textCtrl.Text = textCtrl.Text.Substring(0, 3)
                If textCtrl.Name = "TextBox1" Then
                    textCtrl = TextBox2
                ElseIf textCtrl.Name = "TextBox2" Then
                    textCtrl = TextBox3
                ElseIf textCtrl.Name = "TextBox3" Then
                    textCtrl = TextBox4
                End If
                textCtrl.Focus()
                If (e.KeyChar.ToString() = ".") Or (text.Length > 3) Then
                    e.Handled = True
                End If
            End If
        End If
    End Sub
    Public Function GetAddress() As Long
        Return (TextBox1.Text * 2 ^ 24 Or TextBox2.Text * 2 ^ 16 Or TextBox3.Text * 2 ^ 8 Or TextBox4.Text * 2 ^ 0)
    End Function
    Public Function GetAddressString() As String
        Return (TextBox1.Text & "." & TextBox2.Text & "." & TextBox3.Text & "." & TextBox4.Text)
    End Function
    Public Sub SetAddress(ByVal addr As String)
        Dim regString As String = "(?<ip>(\d)+)\.*"
        Dim theReg As New Regex(regString)
        Dim theMatches As MatchCollection = theReg.Matches(addr)
        Dim i As Byte = 0
        Dim textCtrl() As TextBox = {TextBox1, TextBox2, TextBox3, TextBox4}
        Dim theMatch As Match
        For Each theMatch In theMatches
            If theMatch.Value.Contains(".") Then
                textCtrl(i).Text = theMatch.Value.Remove(theMatch.Value.Length - 1, 1)
            Else
                textCtrl(i).Text = theMatch.Value
            End If
            i += 1
        Next
    End Sub
    Public Sub SetAddress(ByVal addr As Long)
        TextBox4.Text = addr Mod 256
        addr \= 256
        TextBox3.Text = addr Mod 256
        addr \= 256
        TextBox2.Text = addr Mod 256
        addr \= 256
        TextBox1.Text = addr Mod 256
    End Sub

End Class

