﻿Imports System
Imports System.IO
Imports System.Text.RegularExpressions
Imports System.Runtime.Serialization.Formatters.Binary
Public Class Connection
    Public theMDIParent As Pulsar320AppMain
    Private isEdit As Boolean
    Private Sub Add_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Add.Click
        Dim editCtrl As New IPDialog(Me, "", "", "", "")
        isEdit = False
        editCtrl.ShowDialog()
    End Sub

    Private Sub Connection_Disposed(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Disposed, Me.Closing
        Dim s As String = "tcpdata.bin"
        Dim boxData As New ArrayList
        Dim lineData As String
        Dim formatter As New BinaryFormatter

        Dim streamIn As New FileStream(s, FileMode.Create, FileAccess.Write)

        For Each lineData In Me.ConnectName.Items
            boxData.Add(lineData)
        Next
        formatter.Serialize(streamIn, boxData)

        streamIn.Close()

    End Sub
    Private Sub Connection_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make it a child of this MDI form before showing it.
        Dim s As String = "tcpdata.bin"

        If File.Exists(s) Then
            Dim lineData As ArrayList
            Dim streamOut As FileStream
            Dim itm As String
            streamOut = Nothing
            Try
                Dim formatter As New BinaryFormatter

                streamOut = New FileStream(s, FileMode.Open, FileAccess.Read)

                lineData = CType(formatter.Deserialize(streamOut), ArrayList)

                For Each itm In lineData
                    Me.ConnectName.Items.Add(itm)
                Next

            Catch

            End Try
            streamOut.Close()
        End If

    End Sub

    Private Sub Edit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Edit.Click, ConnectName.DoubleClick
        If Me.ConnectName.SelectedIndex <> -1 Then
            Dim regString As String = "(?<name>(\S|\s)+)\:\:\:(?<ip>(\d|\.)+)\:\:\:(?<subnet>(\d|\.)+)\:\:\:(?<gateway>(\d|\.)+)"
            Dim theReg As New Regex(regString)
            Dim name As String
            Dim ip As String
            Dim subnet As String
            Dim gateway As String
            name = theReg.Match(ConnectName.Items.Item(ConnectName.SelectedIndex)).Groups("name").ToString
            ip = theReg.Match(ConnectName.Items.Item(ConnectName.SelectedIndex)).Groups("ip").ToString
            subnet = theReg.Match(ConnectName.Items.Item(ConnectName.SelectedIndex)).Groups("subnet").ToString
            gateway = theReg.Match(ConnectName.Items.Item(ConnectName.SelectedIndex)).Groups("gateway").ToString
            isEdit = True
            Dim editCtrl As New IPDialog(Me, name, ip, subnet, gateway)
            editCtrl.ShowDialog()
        End If
    End Sub

    Private Sub Remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Remove.Click
        Dim tempIndex As Integer
        tempIndex = ConnectName.SelectedIndex
        If tempIndex >= 0 Then
            ConnectName.Items.RemoveAt(tempIndex)
            tempIndex = Math.Min(ConnectName.Items.Count - 1, tempIndex)
            ConnectName.SelectedIndex = tempIndex
        End If
    End Sub

    Private Sub Connect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Connect.Click
        If Me.ConnectName.SelectedIndex <> -1 Then
            Dim regString As String = "(?<name>(\S|\s)+)\:\:\:(?<ip>(\d|\.)+)\:\:\:(?<subnet>(\d|\.)+)\:\:\:(?<gateway>(\d|\.)+)"
            Dim theReg As New Regex(regString)
            Dim name As String
            Dim ip As String
            name = theReg.Match(ConnectName.Items.Item(ConnectName.SelectedIndex)).Groups("name").ToString
            ip = theReg.Match(ConnectName.Items.Item(ConnectName.SelectedIndex)).Groups("ip").ToString
            theMDIParent.launchConfig(Me.ConnectName.SelectedIndex + 25, ip)
            Me.Close()
        End If
    End Sub
    Public Sub addrChange(ByVal name As String, ByVal ip As String, ByVal subnet As String, ByVal gateway As String)
        Dim newString As String
        newString = name & ":::" & ip & ":::" & subnet & ":::" & gateway
        If isEdit Then
            ConnectName.Items.Insert(ConnectName.SelectedIndex, newString)
            ConnectName.Items.RemoveAt(ConnectName.SelectedIndex)
        Else
            ConnectName.Items.Add(newString)
        End If
        'editCtrl.Dispose()
    End Sub

    Public Sub New(ByRef parent As Pulsar320AppMain)

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        theMDIParent = parent
    End Sub
End Class